VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TTGlyphOutline"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'---------------------------------------------------------------------------------------
' Klasse    : TTGlyphOutline
' Datum     : 21.01.2003
' Autor     : G.Beckmann - Email:G.Beckmann@NikoCity.de
' Zweck     : Kapselung der AP-Funktion *GetGlyphOutline*
'             TTPOLYGON-Strukturen in ein Objekt-Ntzwerk berfhren
'---------------------------------------------------------------------------------------
Option Explicit

Public Enum EPolyCurveType
    TT_PRIM_LINE = 1        ' Kurve ist eine Polylinie
    TT_PRIM_QSPLINE = 2     ' Kurve ist eine Bzierkurve
End Enum


Public Type Fixed           ' Im *Fixed Point*-Format reprsentieren 2 Integers
    fract As Integer        ' eine Fliekommazahl.
    value As Integer        ' Als Beispiel(Fract,value): (32768,0) -> 0.5
End Type                    '                            (16384,2) -> 2.25

Public Type MAT2            '
    eM11 As Fixed           ' +- -+     +-                         -+     +- -+
    eM12 As Fixed           ' | x'|     | eM11=cos(A)  eM21=-sin(A) |     | x |
    eM21 As Fixed           ' |   |  =  |                           |  *  |   |
    eM22 As Fixed           ' | y'|     | eM12=sin(A)  eM22= cos(A) |     | y |
End Type                    ' +- -+     +-                         -+     +- -+

Public Type PointFx
    x As Fixed
    y As Fixed
End Type

Public Type POINTSNG
    x As Single
    y As Single
End Type

Private m_mat2 As MAT2

Public Sub SetTransformationMatrix(MAT2Type As MAT2)
    m_mat2 = MAT2Type
End Sub

Public Function GetGlyphOutline(Font As StdFont, Char As String) As TTPolygons
    Dim ab() As Byte
    
    If Not Font Is Nothing Then
        If Len(Char) Then
            ab() = StrConv(Char, vbFromUnicode)
            Set GetGlyphOutline = New TTPolygons
            GetGlyphOutline.init Font, ab(0), m_mat2
        End If
    End If
End Function

                             
Public Function FixedToSingle(fx As Fixed) As Single
    FixedToSingle = CSng(fx.value) + CSng(&HFFFF& And fx.fract) / &H10000
End Function

Public Function SingleToFixed(ByVal r As Single) As Fixed
    Dim i&
    SingleToFixed.value = Int(r)
    i = &H10000 * (r - Int(r))
    If i And &H8000 Then
        SingleToFixed.fract = &H10000 * (r - Int(r)) Or &HFFFF0000
    Else
        SingleToFixed.fract = i
    End If
End Function

Private Sub Class_Initialize()
    m_mat2.eM11.value = 1
    m_mat2.eM22.value = -1
End Sub
