VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TTPolygons"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Klasse    : TTPolygons
' Datum     : 21.01.2003
' Autor     : G.Beckmann - Email:G.Beckmann@NikoCity.de
' Zweck     : Auflistung von Polygonen
'---------------------------------------------------------------------------------------

Option Explicit

'/ API
'Private Const TT_POLYGON_TYPE = 24

'Private Const GGO_BITMAP = 1
'Private Const GGO_METRICS = 0
Private Const GGO_NATIVE = 2

Public Type POINTAPI
    x               As Long
    y               As Long
End Type

Public Type Glyphmetrics
    gmBlackBoxX     As Long
    gmBlackBoxY     As Long
    gmptGlyphOrigin As POINTAPI
    gmCellIncX      As Integer
    gmCellIncY      As Integer
End Type
'---------------------------

Private Type SAFEARRAY
    cDims           As Integer
    fFeatures       As Integer
    cbElements      As Long
    cLocks          As Long
    pvData          As Long
    cElements       As Long ' SAFEARRAYBOUND first dimension
    lLbound         As Long
End Type


Private Declare Function GetGlyphOutlineA& Lib "gdi32" (ByVal hdc&, ByVal uChar&, ByVal fuFormat&, ByRef lpgm As Glyphmetrics, ByVal cbBuffer&, ByRef lpBuffer As Any, ByRef lpmat2 As MAT2)
Private Declare Function GetDC& Lib "user32" (ByVal hwnd&)
Private Declare Function ReleaseDC& Lib "user32" (ByVal hwnd&, ByVal hdc&)
Private Declare Function SelectObject& Lib "gdi32" (ByVal hdc&, ByVal hObject&)
Private Declare Sub RtlMoveMemory Lib "kernel32" (pDst As Any, pSrc As Any, ByVal cBytes&)
Private Declare Sub RtlZeroMemory Lib "kernel32" (pDst As Any, ByVal cBytes&)
Private Declare Function ArrPtr& Lib "msvbvm60.dll" Alias "VarPtr" (ptr() As Any) ' VB5 -> msvbvm50.dll


' Locales
Private m_gm            As Glyphmetrics
Private m_bAscii        As Byte
Private m_colPoly       As Collection
Private m_PolyData      As TTPolyData


'---------------------------------------------------------------------------------------
' Eigenschaften / Methoden
'---------------------------------------------------------------------------------------

Public Property Get Item(ByVal Index As Long) As TTPolygon  ' Default Procedure!
Attribute Item.VB_UserMemId = 0
Attribute Item.VB_MemberFlags = "200"
    Set Item = m_colPoly(Index)
End Property

Public Property Get Count() As Long
    Count = m_colPoly.Count
End Property

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "440"
    Set NewEnum = m_colPoly.[_NewEnum]
End Property

Public Property Get OutlineData() As Variant
    Dim sa As SAFEARRAY, ab() As Byte
    
    sa.cDims = 1
    sa.cbElements = 1
    sa.pvData = m_PolyData.DataPointer
    sa.cElements = m_PolyData.size
    
    RtlMoveMemory ByVal ArrPtr(ab()), VarPtr(sa), 4
    OutlineData = ab()
    RtlZeroMemory ByVal ArrPtr(ab()), 4
End Property

Public Property Get AsciiValue() As Byte
    AsciiValue = m_bAscii
End Property

Public Property Get Metrics() As Glyphmetrics
    Metrics = m_gm
End Property

Public Sub Draw(ByVal hdc As Long, ByVal xOffset As Long, ByVal yOffset As Long)
    Dim polygon     As TTPolygon
    
    For Each polygon In m_colPoly
        polygon.Draw hdc, xOffset, yOffset
    Next polygon
End Sub

Friend Function init(ByVal fnt As IFont, ByVal ascii As Byte, tMat2 As MAT2) As Boolean
    Dim result  As Long
    Dim hdc     As Long
    Dim hFnt    As Long
    Dim polygon As TTPolygon
    Dim size    As Long
    Dim offset  As Long
    
    hdc = GetDC(0)
    hFnt = SelectObject(hdc, fnt.hFont)

    result = GetGlyphOutlineA(hdc, CLng(ascii), GGO_NATIVE, m_gm, 0, ByVal 0&, tMat2)
    If result Then
        Set m_PolyData = New TTPolyData
        m_PolyData.init result
        
        GetGlyphOutlineA hdc, CLng(ascii), GGO_NATIVE, m_gm, result, ByVal m_PolyData.DataPointer, tMat2
        
        '/Objekt-Netzwerk aufbauen
        Do Until offset >= result \ 2
            Set polygon = New TTPolygon
            size = polygon.init(m_PolyData, offset)
            m_colPoly.Add polygon
            offset = offset + size
        Loop
        
        init = True
    End If
    
    m_bAscii = ascii
    SelectObject hdc, hFnt
    ReleaseDC 0, hdc
End Function



'---------------------------------------------------------------------------------------
' Ereignisse
'---------------------------------------------------------------------------------------

Private Sub Class_Initialize()
    Set m_colPoly = New Collection
End Sub

Private Sub Class_Terminate()
    '/ Aufrumen
    Set m_PolyData = Nothing
    Set m_colPoly = Nothing    '  destroys collection when this class is terminated
End Sub



