VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "GlyphOutlineDemo"
   ClientHeight    =   8775
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   12975
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   585
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   865
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkShowLbl 
      Caption         =   "Show Label"
      Height          =   375
      Left            =   2520
      TabIndex        =   7
      Top             =   7920
      Width           =   1335
   End
   Begin VB.CheckBox chkMirror 
      Caption         =   "Transform graphical object"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   8280
      Value           =   1  'Checked
      Width           =   2295
   End
   Begin VB.ListBox lstFonts 
      Height          =   1425
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   4
      Top             =   120
      Width           =   3855
   End
   Begin VB.CheckBox chkMetrics 
      Caption         =   "Show Metrics"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   7920
      Width           =   1335
   End
   Begin VB.PictureBox picCanvas 
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000018&
      Height          =   8535
      Left            =   4200
      ScaleHeight     =   -565
      ScaleLeft       =   397
      ScaleMode       =   0  'User
      ScaleTop        =   325
      ScaleWidth      =   -573
      TabIndex        =   2
      Top             =   120
      Width           =   8655
      Begin VB.Label lblPreview 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "B"
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   27.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H0000C000&
         Height          =   630
         Left            =   3600
         TabIndex        =   6
         ToolTipText     =   "Vergleichslabel"
         Top             =   2760
         Width           =   375
      End
   End
   Begin VB.PictureBox picCharSel 
      Height          =   3870
      Left            =   120
      ScaleHeight     =   254
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   253
      TabIndex        =   1
      Top             =   1680
      Width           =   3855
   End
   Begin MSComctlLib.TreeView tvInfo 
      Height          =   2175
      Left            =   120
      TabIndex        =   0
      Top             =   5640
      Width           =   3855
      _ExtentX        =   6800
      _ExtentY        =   3836
      _Version        =   393217
      HideSelection   =   0   'False
      Indentation     =   212
      LabelEdit       =   1
      LineStyle       =   1
      Style           =   7
      Appearance      =   1
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub RtlMoveMemory Lib "kernel32" (pDst As Any, pSrc As Any, ByVal cBytes&)
Private Declare Sub RtlZeroMemory Lib "kernel32" (pDst As Any, ByVal cBytes&)

Private m_polygons  As TTPolygons
Private fnt         As StdFont
Private Canvas      As cCanvas
Private m_char      As String
Private m_lblX      As Single
Private m_lblY      As Single

Private Sub chkMetrics_Click()
    If chkMetrics.Value = vbChecked Then
        Canvas.Metrics = True
    Else
        Canvas.Metrics = False
    End If
    Canvas.DrawPolygons m_polygons
    lblPreview.Refresh
End Sub

Private Sub chkMirror_Click()
    Canvas.MirrorY -chkMirror.Value
    lstFonts_Click
    lblPreview.Refresh
End Sub

Private Sub chkShowLbl_Click()
    lblPreview.Visible = -chkShowLbl.Value
End Sub

Private Sub Form_Load()
    ' Zeichenflche initialisieren
    Set Canvas = New cCanvas
    Canvas.Attach picCanvas
        
    ' Zeichensatz-Objekt initialisieren
    Set fnt = New StdFont
    fnt.Size = 300
    m_char = "A"
    lblPreview.Caption = m_char
    Set lblPreview.Font = fnt
    
    ' Listbox mit TT-Schriften fllen
    With New CEnumFonts
        .FontTypeMask = TRUETYPE_FONTTYPE
        .FillList lstFonts, GET_NAMES
    End With
    lstFonts.Text = "Times new roman"
    
    ' Steuerelemente abgleichen
    chkMirror_Click
    chkMetrics_Click
    chkShowLbl_Click
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Aufrumen
    Set m_polygons = Nothing
    Canvas.Detach
    Set Canvas = Nothing
End Sub

Private Sub lstFonts_Click()
    ' Neuen Font selektieren
    fnt.Name = lstFonts.Text
    Set m_polygons = GetGlyphOutline(fnt, m_char)
    filltv tvInfo, m_polygons
    Canvas.DrawPolygons m_polygons
End Sub

Private Sub picCharSel_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    ' Neues Zeichen selektieren
    m_char = Chr$((CLng(y) \ 16) * 16 + CLng(x) \ 16)
    Set m_polygons = GetGlyphOutline(fnt, m_char)
    filltv tvInfo, m_polygons
    lblPreview.Caption = m_char
    Canvas.DrawPolygons m_polygons
End Sub

Private Sub picCharSel_Paint()
    '/ Raster mit Schriftzeichen malen
    Dim c   As Long
    For c = 0 To 255
        picCharSel.CurrentX = (c Mod 16) * 16 + 4
        picCharSel.CurrentY = (c \ 16) * 16
        picCharSel.Print Chr$(c)
    Next c
End Sub

Private Sub tvInfo_NodeClick(ByVal Node As MSComctlLib.Node)
    Dim s           As String
    Dim pos1        As Long
    Dim pos2        As Long
    Dim Polycurve   As ttpolycurve
    Dim Polygon     As TTPolygon
    
    s = Node.Key
    
    If Len(s) Then
        ' Polygon-Bestandteile hervorheben
        Select Case Left$(s, 2)
        Case "PC"
            RtlMoveMemory Polycurve, CLng(Mid$(s, 3)), 4
            Canvas.HighlightPolyCurve m_polygons, Polycurve
            RtlZeroMemory Polycurve, 4
         Case "PG"
            RtlMoveMemory Polygon, CLng(Mid$(s, 3)), 4
            Canvas.HighlightPolygone m_polygons, Polygon
            RtlZeroMemory Polygon, 4
         Case "PT"
            pos1 = InStr(s, "|")
            pos2 = InStr(pos1 + 1, s, "|")
            Canvas.HighlightPoint m_polygons, CLng(Mid$(s, 3, pos1 - 3)), CLng(Mid$(s, pos1 + 1, pos2 - pos1 - 1))
         End Select
    Else
        Canvas.DrawPolygons m_polygons
    End If
    lblPreview.Refresh
End Sub

'/ Label mit Maus verschieben
Private Sub lblPreview_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    m_lblX = x
    m_lblY = y
End Sub

Private Sub lblPreview_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 1 Then
        lblPreview.Move lblPreview.Left / 1 + (x / 15 - m_lblX / 15), lblPreview.Top / 1 + (y / 15 - m_lblY / 15)
    End If
End Sub


Private Sub filltv(ByVal tv As TreeView, polygons As TTPolygons)
    Dim Polygon     As TTPolygon
    Dim Polycurve   As ttpolycurve
    Dim nod         As Node
    Dim nodRoot     As Node
    Dim nodPoly     As Node
    Dim c           As Long
    Dim sx          As String
    Dim sy          As String
    Dim sPCType     As String
    
    tv.Nodes.Clear
    
    Set nodRoot = tv.Nodes.Add(, , , "TTPoligon - Ascii:" & m_polygons.AsciiValue & " ( " & Chr$(m_polygons.AsciiValue) & " )")
    nodRoot.Expanded = True
    
    '/ Poligone auflisten
    For Each Polygon In polygons
        sx = Format$(FixedToSingle(Polygon.StartPoint.x), " #.00")
        sy = Format$(FixedToSingle(Polygon.StartPoint.y), " #.00")
        Set nodPoly = tv.Nodes.Add(nodRoot, tvwChild, "PG" & ObjPtr(Polygon), "Polygon - Startpunkt (x:" & sx & " y:" & sy & ")")
        nodPoly.Expanded = True
        
        '/ Poly-Kurven auflisten
        For Each Polycurve In Polygon.TTPolyCurves
            sPCType = Choose(Polycurve.PolyCurveType, "Polyline", "Bzierspline")
            Set nod = tv.Nodes.Add(nodPoly, tvwChild, "PC" & ObjPtr(Polycurve), "Polykurve " & Polycurve.Id & " - " & sPCType)
            
            '/ Punkte auflisten
            For c = 0 To Polycurve.Count - 1
                sx = Format$(FixedToSingle(Polycurve.Item(c).x), " #.00")
                sy = Format$(FixedToSingle(Polycurve.Item(c).y), " #.00")
            
                tv.Nodes.Add nod, tvwChild, "PT" & CLng(sx) & "|" & CLng(sy) & "|" & tv.Nodes.Count, "Punkt (x:" & sx & " y:" & sy & ")"
            Next c
        Next Polycurve
    Next Polygon

End Sub
